package wesen.util;

/**
 * Hier sind einige mathematische Methoden, welche in verschiedenen Klassen benutzt werden. 
 * Diese sind hier statisch abgelegt.
 *
 * @author Hugo Graf
 * @version 1.0
 */
public class Geometrie {

  Geometrie() {}

  /**
   * Berechnet die Distanz zwischen zwei Punkten in einem 2D-Koordinaten System
   *
   * @param x1 X des ersten Punktes
   * @param y1 Y des ersten Punktes
   * @param x2 X des zweiten Punktes
   * @param y2 y des zweiten Punktes
   *
   * @return Distanz zwischen den zwei Punkten
   */
  public static double getDistance(double x1, double y1, double x2, double y2) {
    double  x = x1 - x2;
    double  y = y1 - y2;
    double  diff = Math.sqrt(x * x + y * y);

    return diff;
  } // getDistance 

}

