package wesen.util;

import java.io.*;
import java.util.*;
import java.awt.*;

/**
 * Mit dieser Klasse kann ein Objekt geklont werden, dabei muss es serialisiert sein.
 * Auch alle Objekte die dieses Objekt anlegt muessen serialisiert sein.
 * Diese Klasse hat ein schlechtes Laufzeitverhalten, aber ist ein einfache Loesung
 * um Objekte zu klonen.
 *
 * @author Java World und Hugo Graf
 * @version 1.0
 * @since 18.07.2001
 */
public class ObjectCloner {


  /**
   * Dieser Konstruktor kann nicht benutzt werden
   */
  private ObjectCloner() {}

  /**
   * Von einem Objekt wird eine Kopie erstellt, dabei wird "deep Copy" durchgefuehrt.
   *
   * @param oldObj Das zu kopierende Objekt.
   *
   * @return Referenz auf das neu erstellte Objekt.
   *
   * @throws Exception Jeder Fehlerfall
   */
  static public Object deepCopy(Object oldObj) throws Exception {
    ObjectOutputStream  oos = null;
    ObjectInputStream   ois = null;

    try {
      ByteArrayOutputStream bos = new ByteArrayOutputStream();  

      oos = new ObjectOutputStream(bos);                        

      oos.writeObject(oldObj);                                  
      oos.flush();                                              

      ByteArrayInputStream  bin = 
        new ByteArrayInputStream(bos.toByteArray());            

      ois = new ObjectInputStream(bin);                         

      return ois.readObject();                                  
    } catch (Exception e) {
      System.out.println("Exception in ObjectCloner = " + e);
      throw (e);
    } // catch
    finally {
      // Schliessen der Dateien auch im Falle eines Fehlers.
      oos.close();
      ois.close();
    }  // finally
  } // deepCopy

}

